import { InputChangeEventArgs as InputChangeEventArgs_internal } from "./InputChangeEventArgs";
import { ensureBool } from "igniteui-react-core";
export class IgrInputChangeEventArgs {
    createImplementation() {
        return new InputChangeEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = v;
    }
    get isCompositionInProgress() {
        return this.i.isCompositionInProgress;
    }
    set isCompositionInProgress(v) {
        this.i.isCompositionInProgress = ensureBool(v);
    }
}
