import { __extends, __values } from "tslib";
import * as React from 'react';
import { XButton } from "./XButton";
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, isValidProp, toSpinal, getModifiedProps } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { ButtonDisplayStyle_$type } from './ButtonDisplayStyle';
import { IgrButtonClickEventArgs } from './igr-button-click-event-args';
import { TypeRegistrar } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { IgrFocusEventArgs } from "igniteui-react-core";
var IgrXButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrXButton, _super);
    function IgrXButton(props) {
        var _this = _super.call(this, props) || this;
        _this._wrapper = null;
        _this.mounted = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._clicked = null;
        _this._clicked_wrapped = null;
        _this._gotFocus = null;
        _this._gotFocus_wrapped = null;
        _this._lostFocus = null;
        _this._lostFocus_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        var container;
        if (document) {
            container = document.createElement("div");
        }
        var root;
        root = container;
        if (container != null) {
            root = container;
        }
        _this.requestRender = _this.requestRender.bind(_this);
        _this._portalManager = new PortalManager("buttonContent", _this.requestRender);
        var ren = new ReactRenderer(root, document, true, {}, _this._portalManager);
        _this._wrapper = ren;
        _this._container = _this._wrapper.rootWrapper;
        _this._container.setStyleProperty("display", "inline-block");
        var button = _this.i;
        _this._button = button;
        button.provideContainer(ren);
        if (props) {
            _this.initializeProperties();
        }
        return _this;
    }
    IgrXButton.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrXButton.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var div = React.createElement("div", {
            className: "ig-x-button igr-x-button",
            ref: this._getMainRef,
            children: children
        });
        return div;
    };
    IgrXButton.prototype.requestRender = function () {
        if (this._initialized) {
            this.setState({});
        }
    };
    IgrXButton.prototype._onDisplayChanged = function () {
        this._container.setStyleProperty("display", this.display);
    };
    IgrXButton.prototype._onFlexDirectionChanged = function () {
        this._container.setStyleProperty("flex-direction", this.flexDirection);
    };
    IgrXButton.prototype._onFlexGrowChanged = function () {
        this._container.setStyleProperty("flex-grow", this.flexGrow);
    };
    IgrXButton.prototype._onAlignItemsChanged = function () {
        this._container.setStyleProperty("align-items", this.alignItems);
    };
    //private _getLabelPortal(element: DomWrapper, portalCallback: (portal: DomPortal) => void): void {
    //    this._portalManager.getPortal(element, "TemplateContent", portalCallback);
    //}
    IgrXButton.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrXButton.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrXButton.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrXButton.prototype.destroy = function () {
        this._button.destroy();
        this._wrapper.destroy();
    };
    IgrXButton.prototype.componentWillUnmount = function () {
    };
    IgrXButton.prototype.componentDidMount = function () {
        this._elRef.appendChild(this._container.getNativeElement());
        this.initializeContent();
    };
    IgrXButton.prototype.initializeContent = function () {
        this._styling(this._container.getNativeElement(), this);
        this.updateStyle();
    };
    IgrXButton.prototype.createImplementation = function () {
        return new XButton();
    };
    Object.defineProperty(IgrXButton.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgrXButton._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrXButton.prototype, "minWidth", {
        /**
     * Gets or sets the min width to use for the button.
    */
        get: function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "minHeight", {
        /**
         * Gets or sets the min height to use for the button.
        */
        get: function () {
            return this.i.bt;
        },
        set: function (v) {
            this.i.bt = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "displayType", {
        /**
         * Gets or sets the display style to use for the button.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureEnum(ButtonDisplayStyle_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "density", {
        /**
         * Gets or sets the display density to use for the button.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = ensureEnum(ControlDisplayDensity_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "baseTheme", {
        /**
         * Gets or sets the base built in theme to use for the button.
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = ensureEnum(BaseControlTheme_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualDensity", {
        /**
         * Gets the actual display density to use for the label.
        */
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = ensureEnum(ControlDisplayDensity_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualBorderColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.ng);
        },
        set: function (v) {
            this.i.ng = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualUmbraShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.nr);
        },
        set: function (v) {
            this.i.nr = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualPenumbraShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.no);
        },
        set: function (v) {
            this.i.no = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualAmbientShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.ne);
        },
        set: function (v) {
            this.i.ne = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualRestingElevation", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.ct;
        },
        set: function (v) {
            this.i.ct = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualFocusElevation", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.cr;
        },
        set: function (v) {
            this.i.cr = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualHoverElevation", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualRippleColor", {
        /**
         * Gets or sets the color to use for the ripple when the button is pressed.
        */
        get: function () {
            return brushToString(this.i.np);
        },
        set: function (v) {
            this.i.np = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualCornerRadiusBottomRight", {
        get: function () {
            return this.i.kr ? this.i.kr.b : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.b = +v;
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualCornerRadiusBottomLeft", {
        get: function () {
            return this.i.kr ? this.i.kr.a : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.a = +v;
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualCornerRadiusTopLeft", {
        get: function () {
            return this.i.kr ? this.i.kr.c : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.c = +v;
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualCornerRadiusTopRight", {
        get: function () {
            return this.i.kr ? this.i.kr.d : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.d = +v;
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureActualCornerRadius = function () {
        if (this.i.kr) {
            return;
        }
        this.i.kr = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "actualBackgroundColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nf);
        },
        set: function (v) {
            this.i.nf = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualDisabledBackgroundColor", {
        /**
         * Gets the actual color to use for the disabled background of the button.
        */
        get: function () {
            return brushToString(this.i.nh);
        },
        set: function (v) {
            this.i.nh = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualDisabledBorderColor", {
        /**
         * Gets the actual color to use for the disabled border of the button.
        */
        get: function () {
            return brushToString(this.i.ni);
        },
        set: function (v) {
            this.i.ni = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualDisabledTextColor", {
        /**
         * Gets the actual color to use for the disabled text of the button.
        */
        get: function () {
            return brushToString(this.i.nj);
        },
        set: function (v) {
            this.i.nj = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualDisabledElevation", {
        /**
         * Gets the actual disabled elevation to use for the button.
        */
        get: function () {
            return this.i.cq;
        },
        set: function (v) {
            this.i.cq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualElevationMode", {
        /**
         * Gets the actual disabled elevation to use for the button.
        */
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = ensureEnum(ElevationMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualTextColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nq);
        },
        set: function (v) {
            this.i.nq = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualHoverTextColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nn);
        },
        set: function (v) {
            this.i.nn = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualFocusBackgroundColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nk);
        },
        set: function (v) {
            this.i.nk = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualFocusTextColor", {
        /**
         * Gets the actual color to use for the focused text.
        */
        get: function () {
            return brushToString(this.i.nl);
        },
        set: function (v) {
            this.i.nl = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualHoverBackgroundColor", {
        /**
         * Gets the hover color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nm);
        },
        set: function (v) {
            this.i.nm = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualBorderWidth", {
        /**
         * Gets or sets the Width to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is raised.
        */
        get: function () {
            return brushToString(this.i.qv);
        },
        set: function (v) {
            this.i.qv = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qx);
        },
        set: function (v) {
            this.i.qx = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qy);
        },
        set: function (v) {
            this.i.qy = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qz);
        },
        set: function (v) {
            this.i.qz = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.dy;
        },
        set: function (v) {
            this.i.dy = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is raised.
        */
        get: function () {
            return brushToString(this.i.q2);
        },
        set: function (v) {
            this.i.q2 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qw);
        },
        set: function (v) {
            this.i.qw = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.d1;
        },
        set: function (v) {
            this.i.d1 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.d0;
        },
        set: function (v) {
            this.i.d0 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.dz;
        },
        set: function (v) {
            this.i.dz = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is raised.
        */
        get: function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedCornerRadiusBottomRight", {
        get: function () {
            return this.i.k3 ? this.i.k3.b : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.b = +v;
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k3 ? this.i.k3.a : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.a = +v;
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedCornerRadiusTopLeft", {
        get: function () {
            return this.i.k3 ? this.i.k3.c : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.c = +v;
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedCornerRadiusTopRight", {
        get: function () {
            return this.i.k3 ? this.i.k3.d : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.d = +v;
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureRaisedCornerRadius = function () {
        if (this.i.k3) {
            return;
        }
        this.i.k3 = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "raisedRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.q4);
        },
        set: function (v) {
            this.i.q4 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.pu);
        },
        set: function (v) {
            this.i.pu = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.pw);
        },
        set: function (v) {
            this.i.pw = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.px);
        },
        set: function (v) {
            this.i.px = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.py);
        },
        set: function (v) {
            this.i.py = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dj;
        },
        set: function (v) {
            this.i.dj = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.p1);
        },
        set: function (v) {
            this.i.p1 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.pv);
        },
        set: function (v) {
            this.i.pv = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dm;
        },
        set: function (v) {
            this.i.dm = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dl;
        },
        set: function (v) {
            this.i.dl = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dk;
        },
        set: function (v) {
            this.i.dk = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.p3);
        },
        set: function (v) {
            this.i.p3 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is flat.
        */
        get: function () {
            return brushToString(this.i.p4);
        },
        set: function (v) {
            this.i.p4 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is flat.
        */
        get: function () {
            return brushToString(this.i.p2);
        },
        set: function (v) {
            this.i.p2 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and flat.
        */
        get: function () {
            return brushToString(this.i.pz);
        },
        set: function (v) {
            this.i.pz = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and flat.
        */
        get: function () {
            return brushToString(this.i.p0);
        },
        set: function (v) {
            this.i.p0 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is flat.
        */
        get: function () {
            return this.i.br;
        },
        set: function (v) {
            this.i.br = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatCornerRadiusBottomRight", {
        get: function () {
            return this.i.k0 ? this.i.k0.b : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.b = +v;
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k0 ? this.i.k0.a : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.a = +v;
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatCornerRadiusTopLeft", {
        get: function () {
            return this.i.k0 ? this.i.k0.c : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.c = +v;
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flatCornerRadiusTopRight", {
        get: function () {
            return this.i.k0 ? this.i.k0.d : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.d = +v;
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureFlatCornerRadius = function () {
        if (this.i.k0) {
            return;
        }
        this.i.k0 = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "backgroundColor", {
        /**
         * Gets or sets the color to use for the background when the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.ns);
        },
        set: function (v) {
            this.i.ns = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is disabled.
        */
        get: function () {
            return brushToString(this.i.pg);
        },
        set: function (v) {
            this.i.pg = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.ph);
        },
        set: function (v) {
            this.i.ph = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.pi);
        },
        set: function (v) {
            this.i.pi = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.de;
        },
        set: function (v) {
            this.i.de = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "elevationMode", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.w;
        },
        set: function (v) {
            this.i.w = ensureEnum(ElevationMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "hoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hovered.
        */
        get: function () {
            return brushToString(this.i.p7);
        },
        set: function (v) {
            this.i.p7 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "borderColor", {
        /**
         * Gets or sets the border color to use for the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.nt);
        },
        set: function (v) {
            this.i.nt = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "restingElevation", {
        /**
         * Gets or sets the elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.d2;
        },
        set: function (v) {
            this.i.d2 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "hoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.dp;
        },
        set: function (v) {
            this.i.dp = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "focusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.dn;
        },
        set: function (v) {
            this.i.dn = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "textStyle", {
        /**
         * Gets or sets the use for the button.
        */
        get: function () {
            if (this.i.aa == null) {
                return null;
            }
            return this.i.aa.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.aa = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text of the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.q7);
        },
        set: function (v) {
            this.i.q7 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "hoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.p8);
        },
        set: function (v) {
            this.i.p8 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "rippleColor", {
        /**
         * Gets or sets the color to use for the background of the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.q6);
        },
        set: function (v) {
            this.i.q6 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is raised.
        */
        get: function () {
            return brushToString(this.i.q5);
        },
        set: function (v) {
            this.i.q5 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is raised.
        */
        get: function () {
            return brushToString(this.i.q3);
        },
        set: function (v) {
            this.i.q3 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and raised.
        */
        get: function () {
            return brushToString(this.i.q0);
        },
        set: function (v) {
            this.i.q0 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "raisedFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and raised.
        */
        get: function () {
            return brushToString(this.i.q1);
        },
        set: function (v) {
            this.i.q1 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "focusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused.
        */
        get: function () {
            return brushToString(this.i.p5);
        },
        set: function (v) {
            this.i.p5 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "focusTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when it is focused.
        */
        get: function () {
            return brushToString(this.i.p6);
        },
        set: function (v) {
            this.i.p6 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "borderWidth", {
        /**
         * Gets or sets the width to use for the button border regardless of type.
        */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "cornerRadiusBottomRight", {
        get: function () {
            return this.i.kt ? this.i.kt.b : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.b = +v;
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "cornerRadiusBottomLeft", {
        get: function () {
            return this.i.kt ? this.i.kt.a : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.a = +v;
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "cornerRadiusTopLeft", {
        get: function () {
            return this.i.kt ? this.i.kt.c : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.c = +v;
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "cornerRadiusTopRight", {
        get: function () {
            return this.i.kt ? this.i.kt.d : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.d = +v;
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureCornerRadius = function () {
        if (this.i.kt) {
            return;
        }
        this.i.kt = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "outlinedBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is outlined.
        */
        get: function () {
            return brushToString(this.i.qk);
        },
        set: function (v) {
            this.i.qk = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.qm);
        },
        set: function (v) {
            this.i.qm = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.qn);
        },
        set: function (v) {
            this.i.qn = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.qo);
        },
        set: function (v) {
            this.i.qo = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.du;
        },
        set: function (v) {
            this.i.du = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredOutlined.
        */
        get: function () {
            return brushToString(this.i.qr);
        },
        set: function (v) {
            this.i.qr = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.ql);
        },
        set: function (v) {
            this.i.ql = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.dx;
        },
        set: function (v) {
            this.i.dx = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.dw;
        },
        set: function (v) {
            this.i.dw = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.dv;
        },
        set: function (v) {
            this.i.dv = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is outlined.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedCornerRadiusBottomRight", {
        get: function () {
            return this.i.k2 ? this.i.k2.b : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.b = +v;
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k2 ? this.i.k2.a : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.a = +v;
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedCornerRadiusTopLeft", {
        get: function () {
            return this.i.k2 ? this.i.k2.c : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.c = +v;
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedCornerRadiusTopRight", {
        get: function () {
            return this.i.k2 ? this.i.k2.d : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.d = +v;
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureOutlinedCornerRadius = function () {
        if (this.i.k2) {
            return;
        }
        this.i.k2 = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "outlinedRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.qt);
        },
        set: function (v) {
            this.i.qt = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is outlined.
        */
        get: function () {
            return brushToString(this.i.qu);
        },
        set: function (v) {
            this.i.qu = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is outlined.
        */
        get: function () {
            return brushToString(this.i.qs);
        },
        set: function (v) {
            this.i.qs = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and outlined.
        */
        get: function () {
            return brushToString(this.i.qp);
        },
        set: function (v) {
            this.i.qp = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "outlinedFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and outlined.
        */
        get: function () {
            return brushToString(this.i.qq);
        },
        set: function (v) {
            this.i.qq = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pj);
        },
        set: function (v) {
            this.i.pj = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is fab.
        */
        get: function () {
            return brushToString(this.i.pl);
        },
        set: function (v) {
            this.i.pl = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is fab.
        */
        get: function () {
            return brushToString(this.i.pm);
        },
        set: function (v) {
            this.i.pm = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is fab.
        */
        get: function () {
            return brushToString(this.i.pn);
        },
        set: function (v) {
            this.i.pn = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is fab.
        */
        get: function () {
            return this.i.df;
        },
        set: function (v) {
            this.i.df = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredFab.
        */
        get: function () {
            return brushToString(this.i.pq);
        },
        set: function (v) {
            this.i.pq = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pk);
        },
        set: function (v) {
            this.i.pk = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is floating action button.
        */
        get: function () {
            return this.i.di;
        },
        set: function (v) {
            this.i.di = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is floating action button.
        */
        get: function () {
            return this.i.dh;
        },
        set: function (v) {
            this.i.dh = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is floating action button.
        */
        get: function () {
            return this.i.dg;
        },
        set: function (v) {
            this.i.dg = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is floating action button.
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabCornerRadiusBottomRight", {
        get: function () {
            return this.i.kz ? this.i.kz.b : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.b = +v;
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabCornerRadiusBottomLeft", {
        get: function () {
            return this.i.kz ? this.i.kz.a : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.a = +v;
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabCornerRadiusTopLeft", {
        get: function () {
            return this.i.kz ? this.i.kz.c : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.c = +v;
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabCornerRadiusTopRight", {
        get: function () {
            return this.i.kz ? this.i.kz.d : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.d = +v;
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureFabCornerRadius = function () {
        if (this.i.kz) {
            return;
        }
        this.i.kz = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "fabRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.ps);
        },
        set: function (v) {
            this.i.ps = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pt);
        },
        set: function (v) {
            this.i.pt = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pr);
        },
        set: function (v) {
            this.i.pr = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and fab.
        */
        get: function () {
            return brushToString(this.i.po);
        },
        set: function (v) {
            this.i.po = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fabFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and fab.
        */
        get: function () {
            return brushToString(this.i.pp);
        },
        set: function (v) {
            this.i.pp = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is icon.
        */
        get: function () {
            return brushToString(this.i.p9);
        },
        set: function (v) {
            this.i.p9 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qb);
        },
        set: function (v) {
            this.i.qb = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qc);
        },
        set: function (v) {
            this.i.qc = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qd);
        },
        set: function (v) {
            this.i.qd = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.dq;
        },
        set: function (v) {
            this.i.dq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredIcon.
        */
        get: function () {
            return brushToString(this.i.qg);
        },
        set: function (v) {
            this.i.qg = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qa);
        },
        set: function (v) {
            this.i.qa = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.dt;
        },
        set: function (v) {
            this.i.dt = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.ds;
        },
        set: function (v) {
            this.i.ds = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.dr;
        },
        set: function (v) {
            this.i.dr = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is icon.
        */
        get: function () {
            return this.i.bs;
        },
        set: function (v) {
            this.i.bs = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconCornerRadiusBottomRight", {
        get: function () {
            return this.i.k1 ? this.i.k1.b : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.b = +v;
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k1 ? this.i.k1.a : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.a = +v;
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconCornerRadiusTopLeft", {
        get: function () {
            return this.i.k1 ? this.i.k1.c : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.c = +v;
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconCornerRadiusTopRight", {
        get: function () {
            return this.i.k1 ? this.i.k1.d : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.d = +v;
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.ensureIconCornerRadius = function () {
        if (this.i.k1) {
            return;
        }
        this.i.k1 = new CornerRadius(2);
    };
    Object.defineProperty(IgrXButton.prototype, "iconRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.qi);
        },
        set: function (v) {
            this.i.qi = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is icon.
        */
        get: function () {
            return brushToString(this.i.qj);
        },
        set: function (v) {
            this.i.qj = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is icon.
        */
        get: function () {
            return brushToString(this.i.qh);
        },
        set: function (v) {
            this.i.qh = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and icon.
        */
        get: function () {
            return brushToString(this.i.qe);
        },
        set: function (v) {
            this.i.qe = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "iconFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and icon.
        */
        get: function () {
            return brushToString(this.i.qf);
        },
        set: function (v) {
            this.i.qf = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "inputId", {
        /**
         * Gets or sets the id to use for the internal native checkbox.
        */
        get: function () {
            return this.i.hu;
        },
        set: function (v) {
            this.i.hu = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "id", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.hs;
        },
        set: function (v) {
            this.i.hs = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "display", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.fw;
        },
        set: function (v) {
            this.i.fw = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flexDirection", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.g0;
        },
        set: function (v) {
            this.i.g0 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "flexGrow", {
        /**
         * Gets or sets the flex-grow setting for the button.
        */
        get: function () {
            return this.i.g2;
        },
        set: function (v) {
            this.i.g2 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "alignItems", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.e7;
        },
        set: function (v) {
            this.i.e7 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "value", {
        /**
         * Gets or sets value to use for the checkbox.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "name", {
        /**
         * Gets or sets name to use for the button.
        */
        get: function () {
            return this.i.h2;
        },
        set: function (v) {
            this.i.h2 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "tabIndex", {
        /**
         * Gets or sets TabIndex to use for the checkbox.
        */
        get: function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "ariaLabel", {
        /**
         * Gets or sets the value of the aria-label attribute.
        */
        get: function () {
            return this.i.e9;
        },
        set: function (v) {
            this.i.e9 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "fillAvailableSpace", {
        /**
         * Gets or sets whether the button should fill the available space. If false, the button
         * will use an intrinsic size.
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "focused", {
        /**
         * Gets or sets if the checkbox is Focused.
        */
        get: function () {
            return this.i.focused;
        },
        set: function (v) {
            this.i.focused = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "isFocusStyleEnabled", {
        /**
         * Gets or sets if the button show use styling to show focus.
        */
        get: function () {
            return this.i.az;
        },
        set: function (v) {
            this.i.az = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disableRipple", {
        /**
         * Gets or sets whether to disable the ripple effect for the button.
        */
        get: function () {
            return this.i.at;
        },
        set: function (v) {
            this.i.at = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "actualDisableRipple", {
        /**
         * Gets whether to actually disable the ripple effect for the button.
        */
        get: function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disableHover", {
        /**
         * Gets or sets whether the hover effect is disabled.
        */
        get: function () {
            return this.i.ar;
        },
        set: function (v) {
            this.i.ar = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "isHover", {
        /**
         * Gets or sets whether the checkbox is checked.
        */
        get: function () {
            return this.i.a0;
        },
        set: function (v) {
            this.i.a0 = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disabled", {
        /**
         * Gets or sets whether the checkbox is disabled.
        */
        get: function () {
            return this.i.disabled;
        },
        set: function (v) {
            this.i.disabled = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disableTransitions", {
        /**
         * Gets or sets whether the checkbox transitions are disabled.
        */
        get: function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "disablePointer", {
        /**
         * Gets or sets whether the cursor will change into a pointer when the button is hovered.
        */
        get: function () {
            return this.i.as;
        },
        set: function (v) {
            this.i.as = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "contentPaddingLeft", {
        /**
         * Gets or sets the left padding for the button content.
        */
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "contentPaddingTop", {
        /**
         * Gets or sets the top padding for the button content.
        */
        get: function () {
            return this.i.bk;
        },
        set: function (v) {
            this.i.bk = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "contentPaddingRight", {
        /**
         * Gets or sets the right padding for the button content.
        */
        get: function () {
            return this.i.bj;
        },
        set: function (v) {
            this.i.bj = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "contentPaddingBottom", {
        /**
         * Gets or sets the bottom padding for the button content.
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "horizontalContentAlignment", {
        get: function () {
            return this.i.k5;
        },
        set: function (v) {
            this.i.k5 = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "verticalContentAlignment", {
        get: function () {
            return this.i.q9;
        },
        set: function (v) {
            this.i.q9 = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "clickTunneling", {
        /**
         * Gets or sets if clicking on the button is allowed to tunnel down to button content.
        */
        get: function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgrXButton.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrXButton.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrXButton.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("XButton");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgrXButton.prototype.onDetachedFromUI = function () {
        this.i.onDetachedFromUI();
    };
    IgrXButton.prototype.onAttachedToUI = function () {
        this.i.onAttachedToUI();
    };
    /**
     * Exports visual information about the current state of the grid.
    
    */
    IgrXButton.prototype.exportVisualModel = function () {
        var iv = this.i.d7();
        return (iv);
    };
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    IgrXButton.prototype.exportSerializedVisualModel = function () {
        var iv = this.i.f0();
        return (iv);
    };
    Object.defineProperty(IgrXButton.prototype, "clicked", {
        get: function () {
            return this._clicked;
        },
        set: function (ev) {
            var _this = this;
            if (this._clicked_wrapped !== null) {
                this.i.clicked = delegateRemove(this.i.clicked, this._clicked_wrapped);
                this._clicked_wrapped = null;
                this._clicked = null;
            }
            this._clicked = ev;
            this._clicked_wrapped = function (o, e) {
                var outerArgs = new IgrButtonClickEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeClicked) {
                    _this.beforeClicked(_this, outerArgs);
                }
                if (_this._clicked) {
                    _this._clicked(_this, outerArgs);
                }
            };
            this.i.clicked = delegateCombine(this.i.clicked, this._clicked_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "gotFocus", {
        get: function () {
            return this._gotFocus;
        },
        set: function (ev) {
            var _this = this;
            if (this._gotFocus_wrapped !== null) {
                this.i.gotFocus = delegateRemove(this.i.gotFocus, this._gotFocus_wrapped);
                this._gotFocus_wrapped = null;
                this._gotFocus = null;
            }
            this._gotFocus = ev;
            this._gotFocus_wrapped = function (o, e) {
                var outerArgs = new IgrFocusEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeGotFocus) {
                    _this.beforeGotFocus(_this, outerArgs);
                }
                if (_this._gotFocus) {
                    _this._gotFocus(_this, outerArgs);
                }
            };
            this.i.gotFocus = delegateCombine(this.i.gotFocus, this._gotFocus_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXButton.prototype, "lostFocus", {
        get: function () {
            return this._lostFocus;
        },
        set: function (ev) {
            var _this = this;
            if (this._lostFocus_wrapped !== null) {
                this.i.lostFocus = delegateRemove(this.i.lostFocus, this._lostFocus_wrapped);
                this._lostFocus_wrapped = null;
                this._lostFocus = null;
            }
            this._lostFocus = ev;
            this._lostFocus_wrapped = function (o, e) {
                var outerArgs = new IgrFocusEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeLostFocus) {
                    _this.beforeLostFocus(_this, outerArgs);
                }
                if (_this._lostFocus) {
                    _this._lostFocus(_this, outerArgs);
                }
            };
            this.i.lostFocus = delegateCombine(this.i.lostFocus, this._lostFocus_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrXButton;
}(React.Component));
export { IgrXButton };
