import { __extends, __values } from "tslib";
import * as React from 'react';
import { XIcon } from "./XIcon";
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, isValidProp, toSpinal, getModifiedProps, fromBrushCollection, toBrushCollection } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
var IgrXIcon = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrXIcon, _super);
    function IgrXIcon(props) {
        var _this = _super.call(this, props) || this;
        _this._wrapper = null;
        _this._implementation = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        var container;
        if (document) {
            container = document.createElement("div");
        }
        var root;
        root = container;
        if (container != null) {
            root = container;
        }
        _this.requestRender = _this.requestRender.bind(_this);
        _this._portalManager = new PortalManager("iconContent", _this.requestRender);
        var ren = new ReactRenderer(root, document, true, {}, _this._portalManager);
        _this._wrapper = ren;
        _this._container = _this._wrapper.rootWrapper;
        _this._container.setStyleProperty("display", "inline-block");
        _this._container.setStyleProperty("vertical-align", "middle");
        var icon = _this.i;
        _this._icon = icon;
        icon.provideContainer(ren);
        if (props) {
            _this.initializeProperties();
        }
        return _this;
    }
    IgrXIcon.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrXIcon.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var div = React.createElement("div", {
            className: "ig-x-icon igr-x-icon",
            ref: this._getMainRef,
            children: children
        });
        return div;
    };
    IgrXIcon.prototype.requestRender = function () {
        if (this._initialized) {
            this.setState({});
        }
    };
    //private _getLabelPortal(element: DomWrapper, portalCallback: (portal: DomPortal) => void): void {
    //    this._portalManager.getPortal(element, "TemplateContent", portalCallback);
    //}
    IgrXIcon.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrXIcon.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrXIcon.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrXIcon.prototype.destroy = function () {
        this._icon.destroy();
        this._wrapper.destroy();
    };
    IgrXIcon.prototype.componentWillUnmount = function () {
    };
    IgrXIcon.prototype.componentDidMount = function () {
        this._elRef.appendChild(this._container.getNativeElement());
        this.initializeContent();
    };
    IgrXIcon.prototype.initializeContent = function () {
        this._styling(this._container.getNativeElement(), this);
        this.updateStyle();
    };
    IgrXIcon.prototype.createImplementation = function () {
        return new XIcon();
    };
    Object.defineProperty(IgrXIcon.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "baseTheme", {
        /**
     * Gets or sets the base built in theme to use for the button.
    */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureEnum(BaseControlTheme_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "actualFill", {
        /**
         * Gets the fill color currently used by the icon.
        */
        get: function () {
            return brushToString(this.i.cw);
        },
        set: function (v) {
            this.i.cw = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "actualStroke", {
        /**
         * Gets the stroke color currently used by the icon.
        */
        get: function () {
            return brushToString(this.i.cx);
        },
        set: function (v) {
            this.i.cx = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "actualTextColor", {
        /**
         * Gets the text color currently used by the icon.
        */
        get: function () {
            return brushToString(this.i.cy);
        },
        set: function (v) {
            this.i.cy = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "actualStrokeWidth", {
        /**
         * Gets the stroke width currently used by the icon.
        */
        get: function () {
            return this.i.af;
        },
        set: function (v) {
            this.i.af = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "fill", {
        /**
         * Gets or sets the fill color to use for the icon.
        */
        get: function () {
            return brushToString(this.i.fill);
        },
        set: function (v) {
            this.i.fill = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "stroke", {
        /**
         * Gets or sets the stroke color to use for the icon.
        */
        get: function () {
            return brushToString(this.i.dc);
        },
        set: function (v) {
            this.i.dc = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "strokeWidth", {
        /**
         * Gets or sets the stroke thickness to use for the icon.
        */
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "textColor", {
        /**
         * Gets or sets the text color to use for the icon.
        */
        get: function () {
            return brushToString(this.i.dd);
        },
        set: function (v) {
            this.i.dd = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "hoverFill", {
        /**
         * Gets or sets the fill color to use when the icon is hovered.
        */
        get: function () {
            return brushToString(this.i.c5);
        },
        set: function (v) {
            this.i.c5 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "hoverStroke", {
        /**
         * Gets or sets the stroke color to use when the icon is hovered.
        */
        get: function () {
            return brushToString(this.i.c6);
        },
        set: function (v) {
            this.i.c6 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "hoverStrokeThickness", {
        /**
         * Gets or sets the stroke thickness to use when the icon is hovered.
        */
        get: function () {
            return this.i.aj;
        },
        set: function (v) {
            this.i.aj = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "hoverTextColor", {
        /**
         * Gets or sets the text color to use when the icon is hovered.
        */
        get: function () {
            return brushToString(this.i.c7);
        },
        set: function (v) {
            this.i.c7 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "fillColors", {
        /**
         * Gets or sets a collection of fill colors to use in the icon.
         * These colors can be used by SVG elements that have been marked with the
         * ig-icon-fill-#
         * class where # is a number from 0 to count - 1.
        */
        get: function () {
            return fromBrushCollection(this.i.e);
        },
        set: function (v) {
            this.i.e = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "strokeColors", {
        /**
         * Gets or sets a collection of stroke colors to use in the icon.
         * These colors can be used by SVG elements that have been marked with the
         * ig-icon-stroke-#
         * class where # is a number from 0 to count - 1.
        */
        get: function () {
            return fromBrushCollection(this.i.f);
        },
        set: function (v) {
            this.i.f = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "primaryFillColor", {
        /**
         * Gets or sets a primary fill color for the icon.
         * This color is used by SVG elements that have been marked
         * with the
         * ig-icon-primary-fill
         * class.
        */
        get: function () {
            return brushToString(this.i.c8);
        },
        set: function (v) {
            this.i.c8 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "primaryStrokeColor", {
        /**
         * Gets or sets a primary stroke color for the icon.
         * This color is used by SVG elements that have been marked
         * with the
         * ig-icon-primary-stroke
         * class.
        */
        get: function () {
            return brushToString(this.i.c9);
        },
        set: function (v) {
            this.i.c9 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "secondaryFillColor", {
        /**
         * Gets or sets a secondary fill color for the icon.
         * This color is used by SVG elements that have been marked
         * with the
         * ig-icon-secondary-fill
         * class.
        */
        get: function () {
            return brushToString(this.i.da);
        },
        set: function (v) {
            this.i.da = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "secondaryStrokeColor", {
        /**
         * Gets or sets a secondary stroke color for the icon.
         * This color is used by SVG elements that have been marked
         * with the
         * ig-icon-secondary-stroke
         * class.
        */
        get: function () {
            return brushToString(this.i.db);
        },
        set: function (v) {
            this.i.db = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "dataURL", {
        /**
         * Gets or sets data url for the icon to use.
        */
        get: function () {
            return this.i.a7;
        },
        set: function (v) {
            this.i.a7 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "svgPath", {
        /**
         * Gets or sets path data for the icon to use.
        */
        get: function () {
            return this.i.svgPath;
        },
        set: function (v) {
            this.i.svgPath = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "svg", {
        /**
         * Gets or sets svg text for the icon to use.
        */
        get: function () {
            return this.i.svg;
        },
        set: function (v) {
            this.i.svg = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "sVGPaths", {
        /**
         * Gets or sets an array of path data for the icon to use.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "textStyle", {
        /**
         * Gets or sets the use for the button.
        */
        get: function () {
            if (this.i.m == null) {
                return null;
            }
            return this.i.m.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.m = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "id", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "tabIndex", {
        /**
         * Gets or sets TabIndex to use for the checkbox.
        */
        get: function () {
            return this.i.as;
        },
        set: function (v) {
            this.i.as = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "ariaLabel", {
        /**
         * Gets or sets the value of the aria-label attribute.
        */
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "isHover", {
        /**
         * Gets or sets whether the icon is hovered.
        */
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "disabled", {
        /**
         * Gets or sets whether the checkbox is disabled.
        */
        get: function () {
            return this.i.disabled;
        },
        set: function (v) {
            this.i.disabled = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "opacity", {
        get: function () {
            return this.i.ak;
        },
        set: function (v) {
            this.i.ak = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "viewBoxLeft", {
        /**
         * Gets or sets the viewbox left for the svg icon.
        */
        get: function () {
            return this.i.an;
        },
        set: function (v) {
            this.i.an = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "viewBoxTop", {
        /**
         * Gets or sets the viewbox top for the svg icon.
        */
        get: function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "viewBoxWidth", {
        /**
         * Gets or sets the viewbox width for the svg icon.
        */
        get: function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "viewBoxHeight", {
        /**
         * Gets or sets the viewbox height for the svg icon.
        */
        get: function () {
            return this.i.am;
        },
        set: function (v) {
            this.i.am = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "width", {
        /**
         * Gets or sets the width of the icon.
        */
        get: function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrXIcon.prototype, "height", {
        /**
         * Gets or sets the height of the icon.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrXIcon.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgrXIcon.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrXIcon.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrXIcon.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("XIcon");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgrXIcon.prototype.onDetachedFromUI = function () {
        this.i.onDetachedFromUI();
    };
    IgrXIcon.prototype.onAttachedToUI = function () {
        this.i.onAttachedToUI();
    };
    /**
     * Exports visual information about the current state of the grid.
    
    */
    IgrXIcon.prototype.exportVisualModel = function () {
        var iv = this.i.au();
        return (iv);
    };
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    IgrXIcon.prototype.exportSerializedVisualModel = function () {
        var iv = this.i.a9();
        return (iv);
    };
    return IgrXIcon;
}(React.Component));
export { IgrXIcon };
