import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { XInputGroup } from "./XInputGroup";
import { XLabel } from "./XLabel";
import { XInput } from "./XInput";
import { XSuffix } from "./XSuffix";
import { XIcon } from "./XIcon";
import { Popup } from "igniteui-react-core";
import { XCalendar } from "./XCalendar";
import { Rect } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import { DateFormats } from "./DateFormats";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
import { KeyEventArgs } from "igniteui-react-core";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
/**
 * @hidden
 */
export declare class DatePickerView extends Base {
    static $t: Type;
    constructor();
    b: DatePicker;
    am(): void;
    d: DomRenderer;
    private k;
    private e;
    private m;
    private l;
    private j;
    private g;
    private f;
    private i;
    private h;
    get n(): DomWrapper;
    private o;
    ak(a: DomRenderer): void;
    private ad;
    aq(a: XInputGroup): void;
    as(a: XLabel): void;
    ar(a: XInput): void;
    au(a: XSuffix, b: any): void;
    ap(a: XIcon, b: any): void;
    v(): any;
    u(): any;
    r(): any;
    q(): any;
    t(): any;
    s(): any;
    aw(a: boolean): void;
    ay(a: string): void;
    av(): void;
    ah(): void;
    ax(): void;
    an(): void;
    aj(): void;
    private ae;
    z(): void;
    at(a: Popup): void;
    ao(a: XCalendar): void;
    p(): any;
    private ac;
    private aa;
    private ab;
    private ag;
    private y;
    private w;
    private x;
    private al;
    private document_Click;
    private window_Resize;
    a0(a: boolean): Rect;
    a(): number[];
    private c;
    ai(): void;
}
/**
 * @hidden
 */
export declare class DatePicker extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private h;
    private static readonly bq;
    private static readonly br;
    private u;
    private q;
    private o;
    private r;
    private m;
    private n;
    private c;
    private bg;
    private bk;
    private bn;
    private bh;
    private bm;
    private ah;
    private at;
    private ar;
    private a5;
    private ai;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    selectedValueChanged: (sender: any, args: SelectedValueChangedEventArgs) => void;
    db(a: Date, b: Date): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    setName(a: string): void;
    private ae;
    private get af();
    private a7;
    get value(): Date;
    set value(a: Date);
    private a6;
    get ba(): Date;
    set ba(a: Date);
    private bj;
    get b3(): string;
    set b3(a: string);
    private dt;
    get dw(): Brush;
    set dw(a: Brush);
    private static ab;
    private z;
    get ac(): FontInfo;
    set ac(a: FontInfo);
    private bl;
    get cb(): string;
    set cb(a: string);
    private a4;
    get a9(): Date;
    set a9(a: Date);
    private a3;
    get a8(): Date;
    set a8(a: Date);
    private x;
    get y(): ControlDisplayDensity;
    set y(a: ControlDisplayDensity);
    private v;
    get w(): BaseControlTheme;
    set w(a: BaseControlTheme);
    private aa;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    private du;
    get dx(): Brush;
    set dx(a: Brush);
    private ds;
    get dv(): Brush;
    set dv(a: Brush);
    private ao;
    get az(): boolean;
    set az(a: boolean);
    private ap;
    get a0(): boolean;
    set a0(a: boolean);
    private ag;
    get au(): boolean;
    set au(a: boolean);
    private an;
    get ay(): boolean;
    set ay(a: boolean);
    private i;
    get j(): DayOfWeek;
    set j(a: DayOfWeek);
    private k;
    get l(): FirstWeek;
    set l(a: FirstWeek);
    private aq;
    get a1(): boolean;
    set a1(a: boolean);
    private a;
    private d;
    get e(): DateFormats;
    set e(a: DateFormats);
    private bi;
    get by(): string;
    set by(a: string);
    private aj;
    get av(): boolean;
    set av(a: boolean);
    private bd;
    get be(): number;
    set be(a: number);
    private ak;
    get aw(): boolean;
    set aw(a: boolean);
    private am;
    get ax(): boolean;
    set ax(a: boolean);
    private as;
    get a2(): boolean;
    set a2(a: boolean);
    protected da(a: string, b: any, c: any): void;
    protected dd(a: string, b: any, c: any): void;
    private co;
    private dp;
    private dk;
    private dn;
    cr(): void;
    private c0;
    private cz;
    private cy;
    dr(a: string): void;
    private dq;
    private dl;
    cp(): void;
    private al;
    c8(): void;
    c9(): void;
    cs(): void;
    private cn;
    private cm;
    cx(): void;
    dc(): void;
    private dj;
    dm(): void;
    cq(): void;
    focus(a?: boolean): void;
    cw(): void;
    df(): void;
    cv(): void;
    c3(): void;
    c4(): void;
    private di;
    private dg;
    bf(): any;
    bv(): string;
    b(): DatePickerVisualModelExport;
    gotFocus: (sender: any, args: GotFocusEventArgs) => void;
    lostFocus: (sender: any, args: LostFocusEventArgs) => void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
    c5(a: GotFocusEventArgs): void;
    c7(a: LostFocusEventArgs): void;
    c6(a: KeyEventArgs): void;
    c2(a: InputChangeEventArgs): void;
}
