import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs, EventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { SuffixShiftType } from "./SuffixShiftType";
import { PrefixShiftType } from "./PrefixShiftType";
import { Brush } from "igniteui-react-core";
import { LabelShiftType } from "./LabelShiftType";
import { HorizontalAlignment } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { KeyEventArgs } from "igniteui-react-core";
import { InputShiftType } from "./InputShiftType";
import { SuffixVisualModelExport } from "./SuffixVisualModelExport";
import { PrefixVisualModelExport } from "./PrefixVisualModelExport";
import { InputGroupDisplayType } from "./InputGroupDisplayType";
import { BaseControlTheme } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ObservableCollection$1 } from "igniteui-react-core";
import { InputGroupVisualModelExport } from "./InputGroupVisualModelExport";
import { LabelVisualModelExport } from "./LabelVisualModelExport";
import { InputVisualModelExport } from "./InputVisualModelExport";
import { Theme } from "./Theme";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
/**
 * @hidden
 */
export declare class InputGroupView extends Base {
    static $t: Type;
    constructor();
    d: XInputGroup;
    ak(): void;
    ac(a: XInputGroupItem): void;
    ae(a: XInputGroupItem): void;
    ad(): void;
    g(): boolean;
    l: DomRenderer;
    private e;
    private i;
    get w(): any;
    get as(): Path;
    get h(): boolean;
    ah(a: DomRenderer): void;
    get s(): DomWrapper;
    get v(): any;
    get u(): any;
    get x(): any;
    get y(): any;
    private z;
    aq(a: string): void;
    ap(): void;
    private aa;
    al(): void;
    j(): number;
    private f;
    private n;
    private o;
    private p;
    private t;
    private r;
    private q;
    private m;
    ag(): void;
    ai(): void;
    ar(a: FontInfo): void;
    k(a: XLabel): number;
    af(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    c(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    ao(a: XInput): void;
    ab(a: any): void;
    an(a: any): void;
    private aj;
    private am;
}
/**
 * @hidden
 */
export declare class SuffixView extends Base {
    static $t: Type;
    constructor();
    a: XSuffix;
    o(): void;
    d(): boolean;
    private g;
    private b;
    private e;
    get r(): Path;
    m(a: DomRenderer): void;
    q(): void;
    private f;
    p(): void;
    private i;
    private j;
    private c;
    private h;
    l(): void;
    n(): void;
    k(a: any): void;
}
/**
 * @hidden
 */
export declare class PrefixView extends Base {
    static $t: Type;
    constructor();
    a: XPrefix;
    o(): void;
    d(): boolean;
    g: DomRenderer;
    private b;
    private e;
    get r(): Path;
    m(a: DomRenderer): void;
    q(): void;
    private f;
    p(): void;
    private i;
    private j;
    private c;
    private h;
    l(): void;
    n(): void;
    k(a: any): void;
}
/**
 * @hidden
 */
export declare class LabelView extends Base {
    static $t: Type;
    constructor();
    c: XLabel;
    ab(): void;
    f(): boolean;
    k: DomRenderer;
    private d;
    private h;
    get n(): any;
    get aj(): Path;
    get g(): boolean;
    s(): void;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    w(a: DomRenderer): void;
    j(): number;
    af(): void;
    ag(): void;
    ae(): void;
    private o;
    ah(a: string): void;
    y(): void;
    t(): void;
    u(): void;
    z(): void;
    aa(): void;
    private p;
    ac(): void;
    i(): number;
    private q;
    private r;
    private e;
    private l;
    private m;
    v(): void;
    x(): void;
    ai(a: FontInfo): void;
    ad(a: Brush): void;
}
/**
 * @hidden
 */
export declare class InputView extends Base {
    static $t: Type;
    constructor();
    b: XInput;
    as(): void;
    h(): boolean;
    l: DomRenderer;
    private c;
    private j;
    get q(): any;
    get bd(): Path;
    get i(): boolean;
    ap(a: DomRenderer): void;
    a0(a: boolean): void;
    ay(a: boolean): void;
    a5(a: HorizontalAlignment): void;
    a4(a: boolean): void;
    g: boolean;
    private ab;
    private aa;
    private t;
    aw(): void;
    au(): void;
    a9(): void;
    private f;
    a8(): void;
    private k;
    ax(a: string): void;
    az(a: string): void;
    private x;
    private ae;
    private ai;
    private aj;
    private bc;
    private y;
    private z;
    private af;
    private ah;
    private ag;
    private ak;
    private ac;
    private ad;
    private r;
    ba(a: string): void;
    s(): string;
    private u;
    a7(): void;
    p(): number;
    o(): number;
    a3(a: number): void;
    a1(a: number): void;
    at(): void;
    private v;
    private w;
    private d;
    private m;
    private n;
    an(): void;
    aq(): void;
    bb(a: FontInfo): void;
    a6(): void;
    ao(): void;
    ar(a: boolean): void;
    av(): void;
    a2(a: number, b: number): void;
    al(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    private static e;
    private am;
}
/**
 * @hidden
 */
export declare abstract class XInputGroupItem extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private c;
    get e(): string;
    set e(a: string);
    private a;
    get b(): XInputGroup;
    set b(a: XInputGroup);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected g(a: string, b: any, c: any): void;
    protected h(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class XSuffix extends XInputGroupItem {
    static $t: Type;
    constructor();
    private _view;
    get view(): SuffixView;
    set view(a: SuffixView);
    destroy(): void;
    private j;
    get k(): SuffixShiftType;
    set k(a: SuffixShiftType);
    protected h(a: string, b: any, c: any): void;
    private al;
    private ai;
    private ap;
    private ao;
    aj(): void;
    ak(): void;
    private static s;
    private v;
    get z(): string;
    set z(a: string);
    private u;
    get w(): string;
    set w(a: string);
    private n;
    get q(): boolean;
    set q(a: boolean);
    private m;
    private o;
    get disabled(): boolean;
    set disabled(a: boolean);
    am(): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected r(): boolean;
    t(): any;
    y(): string;
    i(): SuffixVisualModelExport;
    appendContentChild(a: any): void;
    provideContainer(a: DomRenderer): void;
}
/**
 * @hidden
 */
export declare class XPrefix extends XInputGroupItem {
    static $t: Type;
    constructor();
    private _view;
    get view(): PrefixView;
    set view(a: PrefixView);
    destroy(): void;
    private j;
    get k(): PrefixShiftType;
    set k(a: PrefixShiftType);
    protected h(a: string, b: any, c: any): void;
    private al;
    private ai;
    private ap;
    private ao;
    aj(): void;
    ak(): void;
    private static s;
    private v;
    get z(): string;
    set z(a: string);
    private u;
    get w(): string;
    set w(a: string);
    private n;
    get q(): boolean;
    set q(a: boolean);
    private m;
    private o;
    get disabled(): boolean;
    set disabled(a: boolean);
    am(): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected r(): boolean;
    t(): any;
    y(): string;
    i(): PrefixVisualModelExport;
    appendContentChild(a: any): void;
    provideContainer(a: DomRenderer): void;
}
/**
 * @hidden
 */
export declare class XInputGroup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private jm;
    appendContentChild(a: any): void;
    j7(a: any): void;
    private c;
    get d(): InputGroupDisplayType;
    set d(a: InputGroupDisplayType);
    private r;
    get t(): ControlDisplayDensity;
    set t(a: ControlDisplayDensity);
    private q;
    get s(): ControlDisplayDensity;
    set s(a: ControlDisplayDensity);
    private js;
    private jt;
    private jr;
    private ju;
    private aj;
    private jl;
    private n;
    get p(): BaseControlTheme;
    set p(a: BaseControlTheme);
    private _view;
    get view(): InputGroupView;
    set view(a: InputGroupView);
    destroy(): void;
    protected j2(a: string, b: any, c: any): void;
    protected j5(a: string, b: any, c: any): void;
    static kr(a: CornerRadius, b: CornerRadius): CornerRadius;
    static oh(a: Thickness, b: Thickness): Thickness;
    private ke;
    private kf;
    private kd;
    private kg;
    private kc;
    private kb;
    private w;
    private u;
    private get a();
    onChildrenMutated(): void;
    private jp;
    get al(): boolean;
    j1(): void;
    lostFocus: (sender: any, e: EventArgs) => void;
    gotFocus: (sender: any, e: EventArgs) => void;
    static o: BaseControlTheme;
    private dw;
    private dx;
    private kv;
    private ol;
    private m9;
    private na;
    private nb;
    private d5;
    private d4;
    private d1;
    private ne;
    private nf;
    private nd;
    private nc;
    private d2;
    private d0;
    private dy;
    private dz;
    private d3;
    private m8;
    private dl;
    private dm;
    private ku;
    private ok;
    private m1;
    private m2;
    private m3;
    private dv;
    private du;
    private dr;
    private m6;
    private m7;
    private m5;
    private m4;
    private ds;
    private dq;
    private dn;
    private dp;
    private dt;
    private m0;
    private db;
    private dc;
    private kt;
    private oj;
    private mt;
    private mu;
    private mv;
    private dk;
    private dj;
    private dg;
    private my;
    private mz;
    private mx;
    private mw;
    private dh;
    private df;
    private dd;
    private de;
    private di;
    private ms;
    private d6;
    private d7;
    private kw;
    private om;
    private nh;
    private ni;
    private nj;
    private ef;
    private ee;
    private eb;
    private nm;
    private nn;
    private nl;
    private nk;
    private ec;
    private ea;
    private d8;
    private d9;
    private ed;
    private ng;
    private ka;
    jv(): void;
    j0(): void;
    jz(): void;
    kh(): void;
    private j4;
    private k0;
    get l6(): Brush;
    set l6(a: Brush);
    private k1;
    get l7(): Brush;
    set l7(a: Brush);
    private as;
    get cg(): number;
    set cg(a: number);
    private at;
    get ch(): number;
    set ch(a: number);
    private ki;
    get ko(): CornerRadius;
    set ko(a: CornerRadius);
    private n8;
    get oe(): Thickness;
    set oe(a: Thickness);
    private a1;
    get cp(): number;
    set cp(a: number);
    private a0;
    get co(): number;
    set co(a: number);
    private ax;
    get cl(): number;
    set cl(a: number);
    private k4;
    get ma(): Brush;
    set ma(a: Brush);
    private k5;
    get mb(): Brush;
    set mb(a: Brush);
    private k3;
    get l9(): Brush;
    set l9(a: Brush);
    private k2;
    get l8(): Brush;
    set l8(a: Brush);
    private ay;
    get cm(): number;
    set cm(a: number);
    private aw;
    get ck(): number;
    set ck(a: number);
    private au;
    get ci(): number;
    set ci(a: number);
    private av;
    get cj(): number;
    set cj(a: number);
    private az;
    get cn(): number;
    set cn(a: number);
    private kz;
    get l5(): Brush;
    set l5(a: Brush);
    private bc;
    get c0(): number;
    set c0(a: number);
    private bn;
    get eg(): number;
    set eg(a: number);
    private k7;
    get md(): Brush;
    set md(a: Brush);
    private kl;
    get ks(): CornerRadius;
    set ks(a: CornerRadius);
    private ob;
    get oi(): Thickness;
    set oi(a: Thickness);
    private cf;
    get e8(): number;
    set e8(a: number);
    private ce;
    get e7(): number;
    set e7(a: number);
    private br;
    get ek(): number;
    set ek(a: number);
    private l3;
    get n6(): Brush;
    set n6(a: Brush);
    private l4;
    get n7(): Brush;
    set n7(a: Brush);
    private lo;
    get nq(): Brush;
    set nq(a: Brush);
    private ln;
    get np(): Brush;
    set np(a: Brush);
    private cc;
    get e5(): number;
    set e5(a: number);
    private bq;
    get ej(): number;
    set ej(a: number);
    private bo;
    get eh(): number;
    set eh(a: number);
    private bp;
    get ei(): number;
    set ei(a: number);
    private cd;
    get e6(): number;
    set e6(a: number);
    private k6;
    get mc(): Brush;
    set mc(a: Brush);
    private bs;
    get el(): number;
    set el(a: number);
    private bt;
    get em(): number;
    set em(a: number);
    private lr;
    get nt(): Brush;
    set nt(a: Brush);
    private lq;
    get ns(): Brush;
    set ns(a: Brush);
    private km;
    get kx(): CornerRadius;
    set kx(a: CornerRadius);
    private oc;
    get on(): Thickness;
    set on(a: Thickness);
    private b1;
    get eu(): number;
    set eu(a: number);
    private b0;
    get et(): number;
    set et(a: number);
    private bx;
    get eq(): number;
    set eq(a: number);
    private lu;
    get nw(): Brush;
    set nw(a: Brush);
    private lv;
    get nx(): Brush;
    set nx(a: Brush);
    private lt;
    get nv(): Brush;
    set nv(a: Brush);
    private ls;
    get nu(): Brush;
    set nu(a: Brush);
    private by;
    get er(): number;
    set er(a: number);
    private bw;
    get ep(): number;
    set ep(a: number);
    private bu;
    get en(): number;
    set en(a: number);
    private bv;
    get eo(): number;
    set eo(a: number);
    private bz;
    get es(): number;
    set es(a: number);
    private lp;
    get nr(): Brush;
    set nr(a: Brush);
    private bd;
    get c1(): number;
    set c1(a: number);
    private be;
    get c2(): number;
    set c2(a: number);
    private lh;
    get mn(): Brush;
    set mn(a: Brush);
    private lg;
    get mm(): Brush;
    set mm(a: Brush);
    private kk;
    get kq(): CornerRadius;
    set kq(a: CornerRadius);
    private oa;
    get og(): Thickness;
    set og(a: Thickness);
    private bm;
    get da(): number;
    set da(a: number);
    private bl;
    get c9(): number;
    set c9(a: number);
    private bi;
    get c6(): number;
    set c6(a: number);
    private lk;
    get mq(): Brush;
    set mq(a: Brush);
    private ll;
    get mr(): Brush;
    set mr(a: Brush);
    private lj;
    get mp(): Brush;
    set mp(a: Brush);
    private li;
    get mo(): Brush;
    set mo(a: Brush);
    private bj;
    get c7(): number;
    set c7(a: number);
    private bh;
    get c5(): number;
    set c5(a: number);
    private bf;
    get c3(): number;
    set c3(a: number);
    private bg;
    get c4(): number;
    set c4(a: number);
    private bk;
    get c8(): number;
    set c8(a: number);
    private lf;
    get ml(): Brush;
    set ml(a: Brush);
    private a2;
    get cq(): number;
    set cq(a: number);
    private a3;
    get cr(): number;
    set cr(a: number);
    private la;
    get mg(): Brush;
    set mg(a: Brush);
    private k9;
    get mf(): Brush;
    set mf(a: Brush);
    private kj;
    get kp(): CornerRadius;
    set kp(a: CornerRadius);
    private n9;
    get of(): Thickness;
    set of(a: Thickness);
    private bb;
    get cz(): number;
    set cz(a: number);
    private ba;
    get cy(): number;
    set cy(a: number);
    private a7;
    get cv(): number;
    set cv(a: number);
    private ld;
    get mj(): Brush;
    set mj(a: Brush);
    private le;
    get mk(): Brush;
    set mk(a: Brush);
    private lc;
    get mi(): Brush;
    set mi(a: Brush);
    private lb;
    get mh(): Brush;
    set mh(a: Brush);
    private a8;
    get cw(): number;
    set cw(a: number);
    private a6;
    get cu(): number;
    set cu(a: number);
    private a4;
    get cs(): number;
    set cs(a: number);
    private a5;
    get ct(): number;
    set ct(a: number);
    private a9;
    get cx(): number;
    set cx(a: number);
    private k8;
    get me(): Brush;
    set me(a: Brush);
    private b2;
    get ev(): number;
    set ev(a: number);
    private b3;
    get ew(): number;
    set ew(a: number);
    private ly;
    get n0(): Brush;
    set n0(a: Brush);
    private lx;
    get nz(): Brush;
    set nz(a: Brush);
    private kn;
    get ky(): CornerRadius;
    set ky(a: CornerRadius);
    private od;
    get oo(): Thickness;
    set oo(a: Thickness);
    private cb;
    get e4(): number;
    set e4(a: number);
    private ca;
    get e3(): number;
    set e3(a: number);
    private b7;
    get e0(): number;
    set e0(a: number);
    private l1;
    get n3(): Brush;
    set n3(a: Brush);
    private l2;
    get n4(): Brush;
    set n4(a: Brush);
    private l0;
    get n2(): Brush;
    set n2(a: Brush);
    private lz;
    get n1(): Brush;
    set n1(a: Brush);
    private b8;
    get e1(): number;
    set e1(a: number);
    private b6;
    get ez(): number;
    set ez(a: number);
    private b4;
    get ex(): number;
    set ex(a: number);
    private b5;
    get ey(): number;
    set ey(a: number);
    private b9;
    get e2(): number;
    set e2(a: number);
    private lw;
    get ny(): Brush;
    set ny(a: Brush);
    private ad;
    private z;
    get an(): boolean;
    set an(a: boolean);
    j8(): void;
    private af;
    private ab;
    get ap(): boolean;
    set ap(a: boolean);
    private ae;
    private aa;
    get ao(): boolean;
    set ao(a: boolean);
    private x;
    get ai(): boolean;
    set ai(a: boolean);
    private lm;
    get no(): Brush;
    set no(a: Brush);
    private static fc;
    private ff;
    get hk(): string;
    set hk(a: string);
    private ac;
    get disabled(): boolean;
    set disabled(a: boolean);
    j3(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    ensureShift(): void;
    protected aq(): boolean;
    fe(): any;
    hb(): string;
    b(): InputGroupVisualModelExport;
    provideContainer(a: DomRenderer): void;
    private f;
    private v;
    private ah;
    private y;
    private ag;
    get inputs(): XInputGroupInputCollection;
    private fd;
    private get fb();
    private j9;
    private get ak();
    private get ar();
    static j: Theme;
    static i: Theme;
    static n5: Brush;
    static l: Theme;
    static k: Theme;
    static m: ThemeResolver;
}
/**
 * @hidden
 */
export declare class XInputGroupInputCollection extends ObservableCollection$1<XInputGroupItem> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class XLabel extends XInputGroupItem {
    static $t: Type;
    constructor();
    private n;
    get p(): BaseControlTheme;
    set p(a: BaseControlTheme);
    private _view;
    get view(): LabelView;
    set view(a: LabelView);
    destroy(): void;
    private get i();
    private aa;
    private z;
    private b8;
    private ci;
    private b9;
    protected h(a: string, b: any, c: any): void;
    private cg;
    private cd;
    private cc;
    private cn;
    private cm;
    static da: Brush;
    static c7: Brush;
    static c9: Brush;
    static c8: Brush;
    static c3: Brush;
    static c0: Brush;
    static c2: Brush;
    static c1: Brush;
    static o: BaseControlTheme;
    static db: Brush;
    static c4: Brush;
    static c6: Brush;
    static c5: Brush;
    private cl;
    private static x;
    private r;
    get t(): ControlDisplayDensity;
    set t(a: ControlDisplayDensity);
    private q;
    get s(): ControlDisplayDensity;
    set s(a: ControlDisplayDensity);
    private cr;
    get cz(): Brush;
    set cz(a: Brush);
    private co;
    get cw(): Brush;
    set cw(a: Brush);
    private cp;
    get cx(): Brush;
    set cx(a: Brush);
    private cq;
    get cy(): Brush;
    set cy(a: Brush);
    private u;
    get w(): FontInfo;
    set w(a: FontInfo);
    private cv;
    get df(): Brush;
    set df(a: Brush);
    private cs;
    get dc(): Brush;
    set dc(a: Brush);
    private ct;
    get dd(): Brush;
    set dd(a: Brush);
    private k;
    get l(): LabelShiftType;
    set l(a: LabelShiftType);
    private af;
    get an(): boolean;
    set an(a: boolean);
    ck(a: boolean, b?: boolean): void;
    private ad;
    get al(): boolean;
    set al(a: boolean);
    ce(): void;
    cf(): void;
    private v;
    get y(): FontInfo;
    set y(a: FontInfo);
    private cu;
    get de(): Brush;
    set de(a: Brush);
    private static at;
    private a2;
    get bu(): string;
    set bu(a: string);
    private ay;
    get bi(): string;
    set bi(a: string);
    private az;
    get bl(): string;
    set bl(a: string);
    private a0;
    get bn(): string;
    set bn(a: string);
    private av;
    get ba(): string;
    set ba(a: string);
    private aw;
    get bc(): string;
    set bc(a: string);
    private ar;
    private ab;
    get aj(): boolean;
    get as(): number;
    set as(a: number);
    private a1;
    get bp(): string;
    set bp(a: string);
    private ax;
    get be(): string;
    set be(a: string);
    private a3;
    get text(): string;
    set text(a: string);
    private ae;
    get am(): boolean;
    set am(a: boolean);
    private ai;
    get aq(): boolean;
    set aq(a: boolean);
    private ac;
    private ah;
    private ag;
    ap: boolean;
    get disabled(): boolean;
    set disabled(a: boolean);
    ch(): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected ao(): boolean;
    au(): any;
    bk(): string;
    j(): LabelVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
/**
 * @hidden
 */
export declare class XInput extends XInputGroupItem {
    static $t: Type;
    private u;
    private a7;
    private a8;
    private q;
    private bp;
    private bj;
    private ah;
    private bk;
    private ai;
    private aq;
    constructor();
    private _view;
    get view(): InputView;
    set view(a: InputView);
    destroy(): void;
    private n;
    get o(): InputShiftType;
    set o(a: InputShiftType);
    private v;
    get w(): BaseControlTheme;
    set w(a: BaseControlTheme);
    private y;
    get aa(): ControlDisplayDensity;
    set aa(a: ControlDisplayDensity);
    private x;
    get z(): ControlDisplayDensity;
    set z(a: ControlDisplayDensity);
    private bo;
    get ce(): string;
    set ce(a: string);
    private br;
    get ci(): string;
    set ci(a: string);
    private ak;
    get au(): boolean;
    set au(a: boolean);
    private ar;
    get a1(): boolean;
    set a1(a: boolean);
    protected h(a: string, b: any, c: any): void;
    private di;
    private dk;
    private dj;
    private c8;
    private dv;
    private du;
    static d6: Brush;
    static d5: Brush;
    static ae: FontInfo;
    private d0;
    get d4(): Brush;
    set d4(a: Brush);
    private dz;
    get d3(): Brush;
    set d3(a: Brush);
    private ab;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    private d2;
    get d8(): Brush;
    set d8(a: Brush);
    cz(): void;
    c7(): void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    keyUp: (sender: any, args: KeyEventArgs) => void;
    keyPress: (sender: any, args: KeyEventArgs) => void;
    gotFocus: (sender: any, e: EventArgs) => void;
    lostFocus: (sender: any, e: EventArgs) => void;
    mouseDown: (sender: any, e: MouseButtonEventArgs) => void;
    mouseUp: (sender: any, e: MouseButtonEventArgs) => void;
    da(a: KeyEventArgs): void;
    dc(a: KeyEventArgs): void;
    db(a: KeyEventArgs): void;
    dd(a: MouseButtonEventArgs): void;
    dg(a: MouseButtonEventArgs): void;
    dh(): void;
    c5(): void;
    c6(): void;
    c0(): void;
    c1(): void;
    c3(): void;
    c2(a: string): void;
    de(): void;
    df(): void;
    private ac;
    get af(): FontInfo;
    set af(a: FontInfo);
    private bn;
    get b8(): string;
    set b8(a: string);
    private bq;
    get cg(): string;
    set cg(a: string);
    private d1;
    get d7(): Brush;
    set d7(a: Brush);
    private static bf;
    private bm;
    get b5(): string;
    set b5(a: string);
    private a9;
    private aj;
    get as(): boolean;
    get be(): number;
    set be(a: number);
    cu(): void;
    private bl;
    get b2(): string;
    set b2(a: string);
    private bi;
    get bx(): string;
    set bx(a: string);
    private an;
    get aw(): boolean;
    set aw(a: boolean);
    bh: any;
    private bs;
    get cq(): string;
    set cq(a: string);
    get at(): boolean;
    private am;
    private al;
    get disabled(): boolean;
    set disabled(a: boolean);
    private ao;
    get readonly(): boolean;
    set readonly(a: boolean);
    private dx;
    get dy(): HorizontalAlignment;
    set dy(a: HorizontalAlignment);
    dl(): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected az(): boolean;
    bg(): any;
    b1(): string;
    j(): InputVisualModelExport;
    change: (sender: any, args: InputChangeEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
    compositionStart: (sender: any, e: EventArgs) => void;
    compositionEnd: (sender: any, args: InputChangeEventArgs) => void;
    dr(a: number, b: number): void;
    provideContainer(a: DomRenderer): void;
    ct(): void;
    focus(a?: boolean): void;
    dp(): void;
    private dt;
    private ds;
    private dw;
    private cs;
    private bb;
    private ba;
    get selectionStart(): number;
    set selectionStart(a: number);
    get selectionEnd(): number;
    set selectionEnd(a: number);
    private ap;
    get ay(): boolean;
    set ay(a: boolean);
    dq(a: boolean, b?: boolean): void;
    private c9;
    private ag;
    a0: boolean;
    private cw;
    private get i();
    private dm;
}
