import * as React from 'react';
import { DatePicker } from './DatePicker';
import { IgrSelectedValueChangedEventArgs } from "./igr-selected-value-changed-event-args";
import { IgrGotFocusEventArgs } from "./igr-got-focus-event-args";
import { IgrLostFocusEventArgs } from "./igr-lost-focus-event-args";
import { IgrInputChangeEventArgs } from "./igr-input-change-event-args";
import { IgrKeyEventArgs } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { DateFormats } from "./DateFormats";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
export declare class IgrDatePicker extends React.Component<IIgrDatePickerProps> {
    private _container;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _renderer;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    constructor(props: IIgrDatePickerProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    private _implementation;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): DatePicker;
    get i(): DatePicker;
    private _datePicker;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get value(): Date;
    set value(v: Date);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get today(): Date;
    set today(v: Date);
    /**
     * Gets or Sets the property name that contains the label.
    */
    get label(): string;
    set label(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get labelTextColor(): string;
    set labelTextColor(v: string);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get labelTextStyle(): string;
    set labelTextStyle(v: string);
    /**
     * Gets or Sets the property name that contains the placeholder.
    */
    get placeholder(): string;
    set placeholder(v: string);
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    get minDate(): Date;
    set minDate(v: Date);
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    get maxDate(): Date;
    set maxDate(v: Date);
    /**
     * Gets or sets the display density to use for the date pcicker.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets or sets the base built in theme to use for the date picker.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or Sets the text color
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or Sets the text color
    */
    get iconColor(): string;
    set iconColor(v: string);
    /**
     * Gets or sets the ShowClearButton property to detirmine if the clear button is shown
    */
    get showClearButton(): boolean;
    set showClearButton(v: boolean);
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    get showTodayButton(): boolean;
    set showTodayButton(v: boolean);
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    get allowTextInput(): boolean;
    set allowTextInput(v: boolean);
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    get openOnFocus(): boolean;
    set openOnFocus(v: boolean);
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    get firstDayOfWeek(): DayOfWeek;
    set firstDayOfWeek(v: DayOfWeek);
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    get firstWeekOfYear(): FirstWeek;
    set firstWeekOfYear(v: FirstWeek);
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    get showWeekNumbers(): boolean;
    set showWeekNumbers(v: boolean);
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    get dateFormat(): DateFormats;
    set dateFormat(v: DateFormats);
    /**
     * Gets or sets the Format property to detirmine the format of the date in the input
    */
    get formatString(): string;
    set formatString(v: string);
    get isDisabled(): boolean;
    set isDisabled(v: boolean);
    /**
     * Indicates that the calendar dropdown will position itself relative to the window instead of the document.
    */
    get isFixed(): boolean;
    set isFixed(v: boolean);
    /**
     * Indicates that the dropdown should open as a child of the date picker.
    */
    get openAsChild(): boolean;
    set openAsChild(v: boolean);
    /**
     * Indicates that the dropdown will place itself into the browser top layer.
    */
    get useTopLayer(): boolean;
    set useTopLayer(v: boolean);
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    select(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _selectedValueChanged;
    private _selectedValueChanged_wrapped;
    /**
     * Called when date is selected.
    */
    get selectedValueChanged(): (s: IgrDatePicker, e: IgrSelectedValueChangedEventArgs) => void;
    set selectedValueChanged(ev: (s: IgrDatePicker, e: IgrSelectedValueChangedEventArgs) => void);
    private _gotFocus;
    private _gotFocus_wrapped;
    get gotFocus(): (s: IgrDatePicker, e: IgrGotFocusEventArgs) => void;
    set gotFocus(ev: (s: IgrDatePicker, e: IgrGotFocusEventArgs) => void);
    private _lostFocus;
    private _lostFocus_wrapped;
    get lostFocus(): (s: IgrDatePicker, e: IgrLostFocusEventArgs) => void;
    set lostFocus(ev: (s: IgrDatePicker, e: IgrLostFocusEventArgs) => void);
    private _keyDown;
    private _keyDown_wrapped;
    get keyDown(): (s: IgrDatePicker, e: IgrKeyEventArgs) => void;
    set keyDown(ev: (s: IgrDatePicker, e: IgrKeyEventArgs) => void);
    private _changing;
    private _changing_wrapped;
    get changing(): (s: IgrDatePicker, e: IgrInputChangeEventArgs) => void;
    set changing(ev: (s: IgrDatePicker, e: IgrInputChangeEventArgs) => void);
    private _valueChange;
    private _valueChange_wrapped;
    get valueChange(): (s: IgrDatePicker, e: Date) => void;
    set valueChange(ev: (s: IgrDatePicker, e: Date) => void);
}
export interface IIgrDatePickerProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    /**
 * Gets or Sets the property name that contains the values.
*/
    value?: Date;
    /**
     * Gets or Sets the property name that contains the values.
    */
    today?: Date;
    /**
     * Gets or Sets the property name that contains the label.
    */
    label?: string;
    /**
     * Gets or sets the color to use for the text.
    */
    labelTextColor?: string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    labelTextStyle?: string;
    /**
     * Gets or Sets the property name that contains the placeholder.
    */
    placeholder?: string;
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    minDate?: Date;
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    maxDate?: Date;
    /**
     * Gets or sets the display density to use for the date pcicker.
    */
    density?: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the date picker.
    */
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    textStyle?: string;
    /**
     * Gets or Sets the text color
    */
    textColor?: string;
    /**
     * Gets or Sets the text color
    */
    iconColor?: string;
    /**
     * Gets or sets the ShowClearButton property to detirmine if the clear button is shown
    */
    showClearButton?: boolean | string;
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    showTodayButton?: boolean | string;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    allowTextInput?: boolean | string;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    openOnFocus?: boolean | string;
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    firstDayOfWeek?: DayOfWeek | string;
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    firstWeekOfYear?: FirstWeek | string;
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    showWeekNumbers?: boolean | string;
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    dateFormat?: DateFormats | string;
    /**
     * Gets or sets the Format property to detirmine the format of the date in the input
    */
    formatString?: string;
    isDisabled?: boolean | string;
    /**
     * Indicates that the calendar dropdown will position itself relative to the window instead of the document.
    */
    isFixed?: boolean | string;
    /**
     * Indicates that the dropdown should open as a child of the date picker.
    */
    openAsChild?: boolean | string;
    /**
     * Indicates that the dropdown will place itself into the browser top layer.
    */
    useTopLayer?: boolean | string;
    /**
 * Called when date is selected.
*/
    selectedValueChanged?: (s: IgrDatePicker, e: IgrSelectedValueChangedEventArgs) => void;
    gotFocus?: (s: IgrDatePicker, e: IgrGotFocusEventArgs) => void;
    lostFocus?: (s: IgrDatePicker, e: IgrLostFocusEventArgs) => void;
    keyDown?: (s: IgrDatePicker, e: IgrKeyEventArgs) => void;
    changing?: (s: IgrDatePicker, e: IgrInputChangeEventArgs) => void;
}
