import * as React from 'react';
import { XLabel } from "./XLabel";
import { IgrXInputGroupItem, IIgrXInputGroupItemProps } from './igr-x-input-group-item';
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
export declare class IgrXLabel extends IgrXInputGroupItem<IIgrXLabelProps> {
    private _container;
    private _initialized;
    private _elRef;
    private _portalManager;
    private _wrapper;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    private requestRender;
    constructor(props: IIgrXLabelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): XLabel;
    private _label;
    private _onDisplayChanged;
    private _onFlexDirectionChanged;
    private _onFlexGrowChanged;
    private _onAlignItemsChanged;
    private _onAlignSelfChanged;
    /**
                             * @hidden
                             */
    get i(): XLabel;
    /**
 * Gets or sets the base built in theme to use for the label.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the display density to use for the label.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display density to use for the label.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual color to use for the text color.
    */
    get actualTextColor(): string;
    set actualTextColor(v: string);
    /**
     * Gets the actual color to use for the text color.
    */
    get actualHighlightTextColor(): string;
    set actualHighlightTextColor(v: string);
    /**
     * Gets the actual color to use for the text color when highlighted and hovered.
    */
    get actualHoverHighlightTextColor(): string;
    set actualHoverHighlightTextColor(v: string);
    /**
     * Gets the actual hover color to use for the text.
    */
    get actualHoverTextColor(): string;
    set actualHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get highlightTextColor(): string;
    set highlightTextColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get hoverHighlightTextColor(): string;
    set hoverHighlightTextColor(v: string);
    /**
     * Gets or sets the use for the button.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button regardless of type.
    */
    get hoverTextColor(): string;
    set hoverTextColor(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get display(): string;
    set display(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get flexDirection(): string;
    set flexDirection(v: string);
    /**
     * Gets or sets the flex-grow setting for the button.
    */
    get flexGrow(): string;
    set flexGrow(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get alignItems(): string;
    set alignItems(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get alignSelf(): string;
    set alignSelf(v: string);
    /**
     * Gets or sets TabIndex to use for the checkbox.
    */
    get tabIndex(): number;
    set tabIndex(v: number);
    /**
     * Gets or sets the for attribute to use for the label.
    */
    get for(): string;
    set for(v: string);
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets the text for the label.
    */
    get text(): string;
    set text(v: string);
    /**
     * Gets or sets whether the label is hovered.
    */
    get isHover(): boolean;
    set isHover(v: boolean);
    /**
     * Gets or sets the value for the label.
    */
    get value(): boolean;
    set value(v: boolean);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
export interface IIgrXLabelProps extends IIgrXInputGroupItemProps {
    children?: React.ReactNode;
    /**
 * Gets or sets the base built in theme to use for the label.
*/
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the display density to use for the label.
    */
    density?: ControlDisplayDensity | string;
    /**
     * Gets the actual display density to use for the label.
    */
    actualDensity?: ControlDisplayDensity | string;
    /**
     * Gets the actual color to use for the text color.
    */
    actualTextColor?: string;
    /**
     * Gets the actual color to use for the text color.
    */
    actualHighlightTextColor?: string;
    /**
     * Gets the actual color to use for the text color when highlighted and hovered.
    */
    actualHoverHighlightTextColor?: string;
    /**
     * Gets the actual hover color to use for the text.
    */
    actualHoverTextColor?: string;
    /**
     * Gets or sets the color to use for the text.
    */
    textColor?: string;
    /**
     * Gets or sets the color to use for the text.
    */
    highlightTextColor?: string;
    /**
     * Gets or sets the color to use for the text.
    */
    hoverHighlightTextColor?: string;
    /**
     * Gets or sets the use for the button.
    */
    textStyle?: string;
    /**
     * Gets or sets the color to use for the hovered text of the button regardless of type.
    */
    hoverTextColor?: string;
    /**
     * Gets or sets the id to use for the checkbox.
    */
    id?: string;
    /**
     * Gets or sets the id to use for the checkbox.
    */
    display?: string;
    /**
     * Gets or sets the id to use for the checkbox.
    */
    flexDirection?: string;
    /**
     * Gets or sets the flex-grow setting for the button.
    */
    flexGrow?: string;
    /**
     * Gets or sets the id to use for the checkbox.
    */
    alignItems?: string;
    /**
     * Gets or sets the id to use for the checkbox.
    */
    alignSelf?: string;
    /**
     * Gets or sets TabIndex to use for the checkbox.
    */
    tabIndex?: number | string;
    /**
     * Gets or sets the for attribute to use for the label.
    */
    for?: string;
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    ariaLabel?: string;
    /**
     * Gets or sets the text for the label.
    */
    text?: string;
    /**
     * Gets or sets whether the label is hovered.
    */
    isHover?: boolean | string;
    /**
     * Gets or sets the value for the label.
    */
    value?: boolean | string;
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    disabled?: boolean | string;
}
