import * as React from 'react';
import { XRipple } from "./XRipple";
export declare class IgrXRipple extends React.Component<IIgrXRippleProps> {
    private _container;
    private _initialized;
    private _elRef;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _top;
    private _left;
    set top(value: string);
    get top(): string;
    set left(value: string);
    get left(): string;
    private _position;
    set position(value: string);
    get position(): string;
    private _wrapper;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
    }, any>;
    constructor(props: IIgrXRippleProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    private _implementation;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): XRipple;
    get i(): XRipple;
    private _ripple;
    /**
 * Gets or sets the target element to inject ripples into.
*/
    get eventSource(): any;
    set eventSource(v: any);
    /**
     * Gets or sets the color to use for the background when the checkbox is unchecked.
    */
    get rippleColor(): string;
    set rippleColor(v: string);
    /**
     * Gets or sets the color to use for the background when the ripple is hovered.
    */
    get hoverColor(): string;
    set hoverColor(v: string);
    /**
     * Gets or sets the actual color to use for the background when the ripple is hovered.
    */
    get actualHoverColor(): string;
    set actualHoverColor(v: string);
    /**
     * Gets or sets the color to use for the actual background when the checkbox is unchecked.
    */
    get actualRippleColor(): string;
    set actualRippleColor(v: string);
    /**
     * Gets or sets the duration to use for the ripple animation.
    */
    get rippleDuration(): number;
    set rippleDuration(v: number);
    /**
     * Gets or sets if the ripple is disabled.
    */
    get isDisabled(): boolean;
    set isDisabled(v: boolean);
    /**
     * Gets or sets if the ripple is centered.
    */
    get isCentered(): boolean;
    set isCentered(v: boolean);
    /**
     * Gets or sets if the ripple is centered.
    */
    get isHoverEnabled(): boolean;
    set isHoverEnabled(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
export interface IIgrXRippleProps {
    children?: React.ReactNode;
    /**
 * Gets or sets the target element to inject ripples into.
*/
    eventSource?: any;
    /**
     * Gets or sets the color to use for the background when the checkbox is unchecked.
    */
    rippleColor?: string;
    /**
     * Gets or sets the color to use for the background when the ripple is hovered.
    */
    hoverColor?: string;
    /**
     * Gets or sets the actual color to use for the background when the ripple is hovered.
    */
    actualHoverColor?: string;
    /**
     * Gets or sets the color to use for the actual background when the checkbox is unchecked.
    */
    actualRippleColor?: string;
    /**
     * Gets or sets the duration to use for the ripple animation.
    */
    rippleDuration?: number | string;
    /**
     * Gets or sets if the ripple is disabled.
    */
    isDisabled?: boolean | string;
    /**
     * Gets or sets if the ripple is centered.
    */
    isCentered?: boolean | string;
    /**
     * Gets or sets if the ripple is centered.
    */
    isHoverEnabled?: boolean | string;
}
