import * as React from 'react';
import { XSuffix } from "./XSuffix";
import { IgrXInputGroupItem, IIgrXInputGroupItemProps } from './igr-x-input-group-item';
export declare class IgrXSuffix extends IgrXInputGroupItem<IIgrXSuffixProps> {
    private _container;
    private _initialized;
    private _elRef;
    private _portalManager;
    private _wrapper;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    private requestRender;
    constructor(props: IIgrXSuffixProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): XSuffix;
    private _suffix;
    /**
                             * @hidden
                             */
    get i(): XSuffix;
    /**
 * Gets or sets the id to use for the checkbox.
*/
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets whether the suffix is hovered.
    */
    get isHover(): boolean;
    set isHover(v: boolean);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
export interface IIgrXSuffixProps extends IIgrXInputGroupItemProps {
    children?: React.ReactNode;
    /**
 * Gets or sets the id to use for the checkbox.
*/
    id?: string;
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    ariaLabel?: string;
    /**
     * Gets or sets whether the suffix is hovered.
    */
    isHover?: boolean | string;
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    disabled?: boolean | string;
}
